/// <reference path="../native.ts" />
/// <reference path="../object.ts" />

namespace trusted.pkistore {
    /**
     * Support CryptoPro provider
     *
     * @export
     * @class ProviderCryptopro
     * @extends {BaseObject<native.PKISTORE.ProviderCryptopro>}
     */
    export class ProviderCryptopro extends BaseObject<native.PKISTORE.ProviderCryptopro> {
        constructor() {
            super();
            this.handle = new native.PKISTORE.ProviderCryptopro();
        }

         /**
         * Ensure that the certificate's private key is available
         *
         * @static
         * @param {Certificate} cert
         * @returns {boolean}
         * @memberOf ProviderCryptopro
         */
        public hasPrivateKey(cert: pki.Certificate): boolean {
            return this.handle.hasPrivateKey(cert.handle);
        }
    }
}
