/// <reference path="../native.ts" />
/// <reference path="../object.ts" />

namespace trusted.utils {
    /**
     * JSON Web Token (LICENSE_MNG)
     * Uses only with CTGOSTCP
     *
     * @export
     * @class License_Mng
     * @extends {BaseObject<native.LICENSE_MNG.License_Mng>}
     */
    export class License_Mng extends BaseObject<native.UTILS.License_Mng> {
       /**
         * Creates an instance of License_Mng.
         *
         *
         * @memberOf License_Mng
         */
        constructor() {
            super();
            this.handle = new native.UTILS.License_Mng();
        }
       /**
         * Add license_mng license to store
         * License must be correct
         *
         * @static
         * @param {string} license license token in LICENSE_MNG format
         * @returns {boolean}
         * @memberof License_Mng
         */
        public addLicense(lic: string): number {
            return this.handle.addLicense(lic);
        }
	   /**
         * Add license_mng license to store
         * License must be correct
         *
         * @static
         * @param {string} license license token in LICENSE_MNG format
         * @returns {boolean}
         * @memberof License_Mng
         */
        public addLicenseFromFile(lic: string): number {
            return this.handle.addLicenseFromFile(lic);
        }
        /**
         * Delete license_mng license from store
         *
         * @static
         * @param {string} license license token
         * @returns {boolean}
         * @memberof License_Mng
         */
        public deleteLicense(lic: string): boolean {
            return this.handle.deleteLicense(lic);
        }
        /**
         * Delete license_mng license from store
         *
         * @static
         * @param {string} license license token
         * @returns {boolean}
         * @memberof License_Mng
         */
        public deleteLicenseOfIndex(index: number): boolean {
            return this.handle.deleteLicenseOfIndex(index);
        }
        /**
         * Delete license_mng license from store
         *
         * @static
         * @param {string} license license token
         * @returns {boolean}
         * @memberof License_Mng
         */
        public getCountLicense(): number {
            return this.handle.getCountLicense();
        } 
		 /**
         * Delete license_mng license from store
         *
         * @static
         * @param {string} license license token
         * @returns {boolean}
         * @memberof License_Mng
         */
        public getLicense(index: number): string {
            return this.handle.getLicense(index);
        } 
		/**
         * Delete license_mng license from store
         *
         * @static
         * @param {string} license license token
         * @returns {boolean}
         * @memberof License_Mng
         */
        public checkLicense(lic: string): string {
            return this.handle.checkLicense(lic);
        } 

        public checkLicenseOfIndex(index: number): string {
            return this.handle.checkLicenseOfIndex(index);
        } 

        public accessOperations(type:number): boolean {
            return this.handle.accessOperations(type);
        } 

        public generateTrial(): string {
            return this.handle.generateTrial();
        } 

        public checkTrialLicense(): string {
            return this.handle.checkTrialLicense();
        } 

    }
}
